import RemoteTime.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

public class RemoteTimeClient 
{
	public static void main(String args[])
	{
		try
		{
			// ORB creation and initialization
			ORB orb = ORB.init(args, null);

			// Gets the root naming context
			org.omg.CORBA.Object objRef = 
			orb.resolve_initial_references("NameService");
			NamingContext ncRef = NamingContextHelper.narrow(objRef);

			// Gets (resolves) the stringified object reference
			// for the time server
			NameComponent nc = new NameComponent("ExactTime", "");
			NameComponent path[] = {nc};
			ExactTime timeObjRef = ExactTimeHelper.narrow(ncRef.resolve(path));

			// Makes requests to the server
			String exactTime = timeObjRef.getTime();
			System.out.println(exactTime);
		}
		catch (Exception e)
		{
			System.out.println("ERROR : " + e) ;
			e.printStackTrace(System.out);
		}
	}
}
