import RemoteTime.*;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;

import java.util.*;
import java.text.*;

// Server object implementation
class ExactTimeServer extends _ExactTimeImplBase 
{
	public String getTime()
	{
		return
			DateFormat.
				getTimeInstance(DateFormat.FULL).
					format(new Date(System.currentTimeMillis()));
	}
}

// Remote application implementation
public class RemoteTimeServer
{
	public static void main(String args[])
	{
		try
		{
			// ORB creation and initialization
			ORB orb = ORB.init(args, null);

			// create the server object and register it
			ExactTimeServer timeServerObjRef = new ExactTimeServer();
			orb.connect(timeServerObjRef);

			// Gets the root naming context
			org.omg.CORBA.Object objRef = 
			orb.resolve_initial_references("NameService");
			NamingContext ncRef = NamingContextHelper.narrow(objRef);

			// Assignes a string name to the object reference (binding)
			NameComponent nc = new NameComponent("ExactTime", "");
			NameComponent path[] = {nc};
			ncRef.rebind(path, timeServerObjRef);

			// Waits for client requests
			java.lang.Object sync = new java.lang.Object();
			synchronized (sync)
			{
				sync.wait();
			}
		}
		catch (Exception e)
		{
			System.out.println("Remote Time server error: " + e);
			e.printStackTrace(System.out);
		}
	}
}
