import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class SimpleBean extends Canvas
{
	private String text = new String();
	int textX = 20, textY = 20;
	transient private Vector actionListeners = new Vector();

	public SimpleBean()
	{
		setBackground(Color.yellow);
		addMouseListener( new LocalMouseListener() );
	}

	public synchronized Dimension getMinimumSize()
	{
		return new Dimension(100,100);
	}

	// Proprieta' "Text" (set)
	public synchronized void setText(String s)
	{
		text = s;
		repaint();
	}

	// Proprieta' "Text" (get)
	public synchronized String getText()
	{
		return text;
	}
	
	// Metodo AllCaps
	public synchronized void allCaps()
	{
		text = text.toUpperCase();
		repaint();
	}

	public synchronized void addActionListener(ActionListener l)
	{
		actionListeners.addElement(l);
	}

	public synchronized void removeActionListener(ActionListener l)
	{
		actionListeners.removeElement(l);
	}

	public void paint(Graphics g)
	{
		g.setColor(Color.black);
		g.setFont(new Font("TimesRoman", Font.BOLD, 18));

		g.drawString(text,textX, textY);
	}

	class LocalMouseListener extends MouseAdapter
	{
		// Risposta alla pressione del mouse: prima viene
		// ridisegnato il contenuto del SimpleBean,
		// poi ogni ActionEventListener viene informato che 
		// e' successo qualcosa
		public void mousePressed(MouseEvent evt)
		{
			// Gestione del click
			textX = evt.getX();
			textY = evt.getY();
			repaint();

			// Segnalazione ai listener
			Enumeration enum = actionListeners.elements();

			while (enum.hasMoreElements() )
			{
			ActionListener actionListener = (ActionListener) enum.nextElement();

			actionListener.actionPerformed
				(
				new ActionEvent
					(
					SimpleBean.this,
					ActionEvent.ACTION_PERFORMED,
					null
					)
				);
			}
		}
	}
}